*CMZ :  2.01/01 12/09/95  20.18.20  by  HERA-B
*-- Author :    Hartwig Albrecht   04/04/95

      SUBROUTINE ME78PC (ID, NP)

************************************************************************
*
* Description: count and print a message
*
* Called from: anywhere
*
* External references: MEERRO, MEWARN
*
* Argument in/out  description
*  ID      pointer identifier. The content of this parameter does
*                  not matter: important is its address.
*  NP              print the message NP times.
*
************************************************************************

      IMPLICIT NONE

#include "arte/Arte.fi"
#include "auto/ERRC.fi"

      INTEGER ID(1), NP, LD, LOCF, K

#include "arte/Arte.ff"
#include "auto/ERRC.ff"

      LD = LOCF (ID)

C much more elegant search algorithms are conceivable, but...:

      DO 10 K = 1, NERRC()
 10   IF (IERRC_ID(K) .EQ. LD)  GO TO 20

      CALL MMBOOK (JERRC, 1)

      K = NERRC()
      IQ(IQERRC_ID(K)) = LD
      CALL CHCTOH (C78, IQ(HQERRC_TEXT(1,K)), NERRC_TEXT)

 20   IQ(IQERRC_CNT(K)) = IQ(IQERRC_CNT(K)) + 1
      IQ(IQERRC_PRNT(K)) = NP
      IQ(IQERRC_FTL(K)) = ILARGEST

      IF (IERRC_CNT(K) .LE. NP)  THEN
        CALL ME78WA
        IF (IERRC_CNT(K) .EQ. NP)
     +    CALL MEWARN ('... last message of this kind')
      END IF

 90   END

************************************************************************
* End of ME78PC
************************************************************************
