>NAME DBKUIP

>MENU /DataBase
>GUIDANCE
Arte banks reading and writing to/from MIZZI files

>COMMAND DBOPEN
>GUIDANCE
Connect logical io unit to database file 
>ACTION dbopenact
>PARAMETER
FNICK 'LUN symbolic name' C
FNAME 'option (ro, rw)' C

>COMMAND DBCLOSE
>GUIDANCE
Disconnect logical io unit from database file
>ACTION dbcloseact
>PARAMETER
CNICK 'LUN symbolic name' C

>COMMAND DBWRITE
>ACTION dbwriteact
>GUIDANCE
Write Arte header bank and subordinate banks to datafile 
>PARAMETER
ADNICK 'LUN symbolic name' C
ADNAME 'Bank Name' C
ADMAJ  'Major revision number' I
ADMIN  'Minor revision number' I

>COMMAND DBREAD
>GUIDANCE
Read Arte header bank and subordinate banks from datafile
>ACTION dbreadact
>PARAMETER
DANICK 'LUN symbolic name' C
DANAME 'Bank Name' C
DAMAJ  'Major revision number' I
DAMIN  'Minor revision number' I
DAOPT  'match rule (one of eq, le, ge, lt, gt)' C

>COMMAND DBLISTFILE
>GUIDANCE
List the content of MIZZI datafile
>ACTION dblfilact
>PARAMETER
DFNICK 'LUN symbolic name' C

>COMMAND DBLEDACOMP
>GUIDANCE
Set/unset Leda compatible DB format
>ACTION dbslcact
>PARAMETER
DFNICK 'Leda compatibility flag (0=Arte, 1=Leda)' I

>COMMAND DBSETKEY
>GUIDANCE
Declare a column of a table to be the LEDA key
>ACTION dbsetkey
>PARAMETER
DFTBL 'Table name' C
DFCLM 'Field name' C

>COMMAND DBSTOREREL
>GUIDANCE
Store relation table in LEDA format.
>ACTION dbstorrel
>PARAMETER
DLUN 'LUN symbolic name' C
DCLM 'Relation table name' C
DMAJ 'Major revision number' I
DMIN 'Minor revision number' I

>COMMAND DBLOADREL
>GUIDANCE
Load relation table in LEDA format.
>ACTION dbloadrel
>PARAMETER
DLUN 'LUN symbolic name' C
DCLM 'Relation table name' C
DMAJ 'Major revision number' I
DMIN 'Minor revision number' I
DOPT 'match rule (one of eq, le, ge, lt, gt)' C
