/***********************************************************************
*
* GUOUT
* written by Siegmund Nowak  04/03/93
*
* Description: GEANT routine called at the end of each event,
*              here used for a call for sorting/storing  MC event banks
*
* called from  GEANT
*
***********************************************************************/
#include <vector.h>
#include "gean/zgkine.hh"
#include "gean/zgmimp.hh"

extern "C" {
   void guout_();
   void crkibk_();
   void crmibk_();
   void crgept_();
}
 
void guout_() {
   extern vector<int>    *hg_vert;
   extern vector<hgmtra> *hg_mtra;
   extern vector<hgmimp> *normal_mimp;
   extern vector<hgmimp> *modul_mimp;
   extern vector<hgmimp> *TRD_mimp;
   extern vector<hgmimp> *TR_mimp;
   extern vector<hgmimp> *RICH_mimp;
   extern vector<hgmtcp> *ECA_ep;
   extern vector<hgmcal> *ECA_mimp;

   crkibk_();
   crmibk_();
   crgept_();

   delete hg_vert;
   delete hg_mtra;
   delete normal_mimp;
   delete modul_mimp;
   delete TRD_mimp;
   delete TR_mimp;
   delete ECA_ep;
   delete ECA_mimp;
   delete RICH_mimp;   
}
/*   END    GUOUT    */
