#ifndef _ZGROT_HH_
#define _ZGROT_HH_

  typedef struct {
  int rotnum;
  float theta1, phi1, theta2, phi2, theta3, phi3;
  int irotm;
  float grot[9], arot[9];
  } hgrot;

class zgrot{
public:

  friend class zgdet;
  friend class zgpos;  
  friend class zgvol;
  friend class zguser;
 
  zgrot() {}
  ~zgrot() {} 
  
  static void ini(int n);
  static void fin();
  static void increase();
  static void Set_ind_pt(int n);
  unsigned int size() { return nrrot[ind_pt] +1; }
  hgrot      *rotpointer(unsigned int i) {return ptrot[ind_pt] + i;}

  int         Readrot(char*, int&);
  int         Create_Grot(int &); 
  int         Checkxy_Grot(const float[], float &);
  void        Arot_par(float &,float &,float &,float &,float [] );
  void        Set_UnitMatrix(float []);

private:
  static  hgrot        *ptrot[33];
  static  int           nrrot[33];
  static  int           maxrot[33];  
  static  int           ind_pt;
};

#endif







