************************************************************************
*
* SILMED
* written by Siegmund Nowak 09/94
*
* This routines defines material constants and media for silicon support
*
*     +----------------------------+
*     |       Be 0.5 mm            |
*     +----------------------------+
*     |   C foam 6% dens  7.5mm    |
*     +----------------------------+
*     |       Be 0.75 mm           |
*     +----------------------------+
*     |                            |
*     |       nothing              |
*     |                            |
*     +----------------------------+
*     |       Be 0.75 mm           |
*     +----------------------------+
*     |   C foam 6% dens 7.5mm     |
*     +----------------------------+
*     |       Be 0.5 mm            |
*     +----------------------------+
*
************************************************************************

      SUBROUTINE SILMED
C-----------------------

      IMPLICIT NONE

      REAL VOL_MIX(2)
      CHARACTER*12 NAM_MIX(2)

      NAM_MIX(1) = 'BERYLLIUM'
      NAM_MIX(2) = 'C-FOAM'
      VOL_MIX(1) = .25
      VOL_MIX(2) = 1.5
      CALL CRMIXT('SIL_SUPPORT',3,2,NAM_MIX,VOL_MIX)

      RETURN
      END


