/***********************************************************************
* SVDGEO
* written by Siegmund Nowak
*
* This routines is the main routine for generating the SVD geometry
*
*       called from GEOMAIN
***********************************************************************/
#include "arte/ArteFlag.h"
#include "gean/ZGESL.h"
#include "gean/ZGDETV.h"

extern "C" {
  void silgeo_();
  void smlgeo_();
  void detgeo_();

  void svdgeo(int mflag) {
     if(zgdetv_.DETV[LGESL_SIL-1] == 'U') return;
     if(zgdetv_.DETV[LGESL_SIL-1] == 'S') detgeo_();
     else if(zgdetv_.DETV[LGESL_SIL-1] == 'L') {
        if(mflag == 0)  silgeo_();  
        else if(mflag ==1)  smlgeo_(); 
     }
  }
}
