*-- Author :    Thomas Lohse   March 8, 1999

      SUBROUTINE KAINEL

************************************************************************
*
* Description: MODE/INEL command;  defines mode and parameters for 
*                                  simulation of inelastic events 
*
* Called from: KUIP
*
* External references:
*
* Argument in/out description
*
************************************************************************

      IMPLICIT NONE

#include "arte/luopts.fi"

      INTEGER L, mes_id_1
      CHARACTER*12 CH

      save mes_id_1

      call KUGETC(CH, L)
      if (CH(1:2).eq.'MB') then
        modemb = 1
      elseif (CH(1:3).eq.'PTT') then
        modemb = 2
      elseif (CH(1:3).eq.'PTC') then
        modemb = 3
      else
        call MEERRC(mes_id_1, 'MODE/INEL: generator mode unknown')
        modemb = 1
      endif
      pt0mb = 0.
      if (modemb.gt.1) then
        call KUGETR(pt0mb)
      endif
      if (pt0mb.eq.0.)  modemb = 1

 90   END

************************************************************************
* End of KAINEL
************************************************************************
