*CMZ :  0.01/02 10/08/94  21.26.46  by  Dominik Ressing
*CMZ :  0.01/01 24/07/94  13.13.55  by  Dominik Ressing
*-- Author :    Dominik Ressing   18/07/94
************************************************************************************
*
* L1JOBCO
* written by Dominik Ressing, 18/07/94 15.08.35
*
* This routines action:
* Connect a JOB: connect job ipoint after job iprev in its queue
*
* Variables   kind         description
*          (in,update,out)
*-----------------------------------------------------------------------------------
* ipoint        in         pointer to new job
* iprev         in         pointer to job after which the new one is to connect
*
************************************************************************************
c
      SUBROUTINE L1JOBCO(ipoint,iprev)
c
      IMPLICIT NONE
c
#include "l1si/l1jobdf.fi"
c
      INTEGER inext,iprev,ipoint
c
c     --- the two jobs may be the same !! (then its at the right place)
      IF ( ipoint.eq.iprev) RETURN
c
c     --- find next job:
      inext = L1JOBstore(iprev)
c     --- connect job inbetween previous and next job
      L1JOBstore(ipoint)           = inext
      L1JOBstore(ipoint+L1JOBprev) = iprev
c     --- set forward pointer from previous
      L1JOBstore(iprev)            = ipoint
c     --- set backward pointer from next job
      IF ( inext.gt.0 ) L1JOBstore(inext+L1JOBprev) = ipoint
c
      RETURN
c
      END
