>NAME L1KUDEF

>MENU /L1SIMU
>GUIDANCE
L1SIMU program parameters control

>COMMAND L1INIT
>GUIDANCE 
Initialize L1SIMU package.
>ACTION KAL1INI
>PARAMETER
+
FILE 'L1SIMU parameters file (like l1simu.dat) name' C 

>COMMAND L1SET
>GUIDANCE 
Set various L1SIMU parameters.
>ACTION KAL1SET
>PARAMETER
ITEM 'parameter to be set' C 
>USER_HELP L1SETHELP

>COMMAND L1TRIG
>GUIDANCE 
Install trigger pairs parameters.
>ACTION KAL1TRI
>PARAMETER
TYPE1 'type of the first pretrigger'  C D='E-' R='E+','E-','MU+','MU-','PI+','PI-'
TYPE2 'type of the second pretrigger'  C D='E-' R='E+','E-','MU+','MU-','PI+','PI-'
+
MINM*ASS 'low invariant mass cut' R D=2.75
MAXM*ASS 'top invariant mass cut' R D=9999.
MINPT1   'low cut on Pt'  R  D=0.5
MAXPT1   'top cut on Pt'  R  D=10.
MINPT2   'low cut on Pt'  R  D=0.5
MAXPT2   'top cut on Pt'  R  D=10.
MINP1    'low cut on momentum' R D=0.
MAXP1    'top cut on momentum' R D=200.
MINP2    'low cut on momentum' R D=0.
MAXP2    'top cut on momentum' R D=200.
EASSYM   'Pair energy assymetry (|E1-E2|/(E1+E2))' R D=1. R=0:1.
>USER_HELP L1TRIHELP

