*CMZ :  0.01/02 18/08/94  16.56.57  by  Dominik Ressing
*-- Author :    Dominik Ressing   18/08/94
************************************************************************
*
* T1KINBE
* written by Dominik Ressing, 18/08/94 16.52.58
*
* This routines action:
* calculates the bending angle for a track of given momentum.
*
* Arguments  kind         description
*          (in,update,out)
*-----------------------------------------------------------------------
* P           in          Pxz of the track
*
*
************************************************************************
c
      REAL FUNCTION T1KINBE(P)
c
      IMPLICIT NONE
c
#include "l1si/l1param.fi"
#include "l1si/l1detdf.fi"
c
      REAL P,a
c
      a = 0.3*T1DETmagB*T1DETmagd/P
      T1KINBE = atan(a*(1 - (a**2)/4.))
c
      RETURN
c
      END
