#ifndef _RCTUPLE_H_
#define _RCTUPLE_H_
//----------------------------------------------------------------------
// Created: 15.08.97  by   Olya Igonkina

// common blocks for ntuples

//----------------------------------------------------------------------

#include <CLHEP/Utilities/fortran.h>

extern "C" 
{
  BEGIN_FORTRAN_COMMON( matchnt)
    int   Nevt;
    int   Nleft;
    int   Nright;
    int   Nmatch;
    int   Nbad; 
    int   Nlost;
    int   Nreal;    
    float Rbad;
    float Rlost;
    int   fromJpsi;
    float RbadB;
    float Rlmtra;
    float Rlelec ;
    float Rlelecj;
    float RlmtraB;
    float RlelecB;
    float RlelecjB;
  END_FORTRAN_COMMON(   matchnt)
}

extern "C" 
{
  BEGIN_FORTRAN_COMMON( deltas)
    int    flag;
    float  deltaX;
    float  deltaY;
    float  deltaTX;
    float  deltaTY;
    float  deltaPE;
    float  chi2;
    float  quality;
    int    ipart1;
    int    ipart2;
    int    imoth1;
    int    imoth2;
    float  leftp;
    float  rightp;
    float  matchX;
    float  matchY;
    float  matchTX;
    float  matchTY;
    float  matchPE;
    float  lpulsX;
    float  lpulsY;
    float  lpulsTX;
    float  lpulsTY;
    float  lpulsPE;
    float  rpulsX;
    float  rpulsY;
    float  rpulsTX;
    float  rpulsTY;
    float  rpulsPE;
  END_FORTRAN_COMMON(   deltas)
}


#endif
