/* Not completed */
/* Not used */

/* Placed here because of the importance of this operation in general. 
   Closely related to functional programming.
   */

// Author V.Balagura (balagura@mail.desy.de)   (09.04.98).

#ifndef _substitution_hh
#define _substitution_hh 1

#include "ptset/global_error.hh"

/* -------------------------------- 0 arg ------------------------------- */
/* -------------------- 0 arg  (1 value 0 ptr) ->  1 -------------------- */
template <class F, class G, class Y1, class Z1>
class Substitution_0_1_0_1 {
 public:
  F f;
  G g;
  Substitution_0_1_0_1(F f_function, G g_function) 
    : f(f_function), g(g_function) {}
  void operator()(Z1 z1) {
    Y1 y1;
    f(&y1);
    if ( global_error() ) return;
    g(y1, z1);
  }
};
template <class F, class G, class Y1, class Z1>
inline Substitution_0_1_0_1<F, G, Y1, Z1> substitute_1_0_1
(F f, G g, Y1*, Z1*) {
  return Substitution_0_1_0_1<F, G, Y1, Z1>(f, g);
}
/* -------------------- 0 arg  (2 value 0 ptr) ->  1 -------------------- */
template <class F, class G, class Y1, class Y2, class Z1>
class Substitution_0_2_0_1 {
 public:
  F f;
  G g;
  Substitution_0_2_0_1(F f_function, G g_function) 
    : f(f_function), g(g_function) {}
  void operator()(Z1 z1) {
    Y1 y1;
    Y2 y2;
    f(&y1, &y2);
    if ( global_error() ) return;
    g(y1, y2, z1);
  }
};
template <class F, class G, class Y1, class Y2, class Z1>
inline Substitution_0_2_0_1<F, G, Y1, Y2, Z1> substitute_2_0_1
(F f, G g, Y1*, Y2*, Z1*) {
  return Substitution_0_2_0_1<F, G, Y1, Y2, Z1>(f, g);
}
/* -------------------- 0 arg  (3 value 0 ptr) ->  1 -------------------- */
template <class F, class G, class Y1, class Y2, class Y3, class Z1>
class Substitution_0_3_0_1 {
 public:
  F f;
  G g;
  Substitution_0_3_0_1(F f_function, G g_function) 
    : f(f_function), g(g_function) {}
  void operator()(Z1 z1) {
    Y1 y1;
    Y2 y2;
    Y3 y3;
    f(&y1, &y2, &y3);
    if ( global_error() ) return;
    g(y1, y2, y3, z1);
  }
};
template <class F, class G, class Y1, class Y2, class Y3, class Z1>
inline Substitution_0_3_0_1<F, G, Y1, Y2, Y3, Z1> substitute_3_0_1
(F f, G g, Y1*, Y2*, Y3*, Z1*) {
  return Substitution_0_3_0_1<F, G, Y1, Y2, Y3, Z1>(f, g);
}
/* -------------------- 0 arg  (4 value 0 ptr) ->  1 -------------------- */
template <class F, class G, class Y1, class Y2, class Y3, class Y4,
  class Z1>
class Substitution_0_4_0_1 {
 public:
  F f;
  G g;
  Substitution_0_4_0_1(F f_function, G g_function) 
    : f(f_function), g(g_function) {}
  void operator()(Z1 z1) {
    Y1 y1;
    Y2 y2;
    Y3 y3;
    Y4 y4;
    f(&y1, &y2, &y3, &y4);
    if ( global_error() ) return;
    g(y1, y2, y3, y4, z1);
  }
};
template <class F, class G, class Y1, class Y2, class Y3, class Y4,
  class Z1>
inline Substitution_0_4_0_1<F, G, Y1, Y2, Y3, Y4, Z1> substitute_4_0_1
(F f, G g, Y1*, Y2*, Y3*, Y4*, Z1*) {
  return Substitution_0_4_0_1<F, G, Y1, Y2, Y3, Y4, Z1>(f, g);
}
/* -------------------- 0 arg  (5 value 0 ptr) ->  1 -------------------- */
template <class F, class G, class Y1, class Y2, class Y3, class Y4, class Y5,
  class Z1>
class Substitution_0_5_0_1 {
 public:
  F f;
  G g;
  Substitution_0_5_0_1(F f_function, G g_function) 
    : f(f_function), g(g_function) {}
  void operator()(Z1 z1) {
    Y1 y1;
    Y2 y2;
    Y3 y3;
    Y4 y4;
    Y5 y5;
    f(&y1, &y2, &y3, &y4, &y5);
    if ( global_error() ) return;
    g(y1, y2, y3, y4, y5, z1);
  }
};
template <class F, class G, class Y1, class Y2, class Y3, class Y4, class Y5,
  class Z1>
inline Substitution_0_5_0_1<F, G, Y1, Y2, Y3, Y4, Y5, Z1> substitute_5_0_1
(F f, G g, Y1*, Y2*, Y3*, Y4*, Y5*, Z1*) {
  return Substitution_0_5_0_1<F, G, Y1, Y2, Y3, Y4, Y5, Z1>(f, g);
}

/* -------------------------------- 1 arg ------------------------------- */
/* -------------------- 1 arg  (1 value 0 ptr) ->  1 -------------------- */
template <class F, class G, class X1, class Y1, class Z1>
class Substitution_1_1_0_1 {
 public:
  F f;
  G g;
  Substitution_1_1_0_1(F f_function, G g_function) 
    : f(f_function), g(g_function) {}
  void operator()(X1 x1, Z1 z1) {
    Y1 y1;
    f(x1, &y1);
    if ( global_error() ) return;
    g(y1, z1);
  }
};
template <class F, class G, class X1, class Y1, class Z1>
inline Substitution_1_1_0_1<F, G, X1, Y1, Z1> substitute_1_0_1
(F f, G g, X1*, Y1*, Z1*) {
  return Substitution_1_1_0_1<F, G, X1, Y1, Z1>(f, g);
}
/* X1: object, Y1: object, Z1: *object */

/* -------------------- 1 arg  (2 value 0 ptr) ->  1 -------------------- */
template <class F, class G, class X1, class Y1, class Y2, class Z1>
class Substitution_1_2_0_1 {
 public:
  F f;
  G g;
  Substitution_1_2_0_1(F f_function, G g_function) 
    : f(f_function), g(g_function) {}
  void operator()(X1 x1, Z1 z1) {
    Y1 y1;
    Y2 y2;
    f(x1, &y1, &y2);
    if ( global_error() ) return;
    g(y1, y2, z1);
  }
};
template <class F, class G, class X1, class Y1, class Y2, class Z1>
inline Substitution_1_2_0_1<F, G, X1, Y1, Y2, Z1> substitute_2_0_1
(F f, G g, X1*, Y1*, Y2*, Z1*) {
  return Substitution_1_2_0_1<F, G, X1, Y1, Y2, Z1>(f, g);
}
/* -------------------- 1 arg  (3 value 0 ptr) ->  1 -------------------- */
template <class F, class G, class X1, class Y1, class Y2, class Y3, class Z1>
class Substitution_1_3_0_1 {
 public:
  F f;
  G g;
  Substitution_1_3_0_1(F f_function, G g_function) 
    : f(f_function), g(g_function) {}
  void operator()(X1 x1, Z1 z1) {
    Y1 y1;
    Y2 y2;
    Y3 y3;
    f(x1, &y1, &y2, &y3);
    if ( global_error() ) return;
    g(y1, y2, y3, z1);
  }
};
template <class F, class G, class X1, class Y1, class Y2, class Y3, class Z1>
inline Substitution_1_3_0_1<F, G, X1, Y1, Y2, Y3, Z1> substitute_3_0_1
(F f, G g, X1*, Y1*, Y2*, Y3*, Z1*) {
  return Substitution_1_3_0_1<F, G, X1, Y1, Y2, Y3, Z1>(f, g);
}
/* -------------------- 1 arg  (4 value 0 ptr) ->  1 -------------------- */
template <class F, class G, class X1, class Y1, class Y2, class Y3, class Y4,
  class Z1>
class Substitution_1_4_0_1 {
 public:
  F f;
  G g;
  Substitution_1_4_0_1(F f_function, G g_function) 
    : f(f_function), g(g_function) {}
  void operator()(X1 x1, Z1 z1) {
    Y1 y1;
    Y2 y2;
    Y3 y3;
    Y4 y4;
    f(x1, &y1, &y2, &y3, &y4);
    if ( global_error() ) return;
    g(y1, y2, y3, y4, z1);
  }
};
template <class F, class G, class X1, class Y1, class Y2, class Y3, class Y4,
  class Z1>
inline Substitution_1_4_0_1<F, G, X1, Y1, Y2, Y3, Y4, Z1> substitute_4_0_1
(F f, G g, X1*, Y1*, Y2*, Y3*, Y4*, Z1*) {
  return Substitution_1_4_0_1<F, G, X1, Y1, Y2, Y3, Y4, Z1>(f, g);
}

/* -------------------------------- 2 arg ------------------------------- */
/* -------------------- 2 arg  (1 value 0 ptr) ->  1 -------------------- */
template <class F, class G, class X1, class X2, class Y1, class Z1>
class Substitution_2_1_0_1 {
 public:
  F f;
  G g;
  Substitution_2_1_0_1(F f_function, G g_function) 
    : f(f_function), g(g_function) {}
  void operator()(X1 x1, X2 x2, Z1 z1) {
    Y1 y1;
    f(x1, x2, &y1);
    if ( global_error() ) return;
    g(y1, z1);
  }
};
template <class F, class G, class X1, class X2, class Y1, class Z1>
inline Substitution_2_1_0_1<F, G, X1, X2, Y1, Z1> substitute_1_0_1
(F f, G g, X1*, X2*, Y1*, Z1*) {
  return Substitution_2_1_0_1<F, G, X1, X2, Y1, Z1>(f, g);
}
/* -------------------- 2 arg  (2 value 0 ptr) ->  1 -------------------- */
template <class F, class G, class X1, class X2, class Y1, class Y2, class Z1>
class Substitution_2_2_0_1 {
 public:
  F f;
  G g;
  Substitution_2_2_0_1(F f_function, G g_function) 
    : f(f_function), g(g_function) {}
  void operator()(X1 x1, X2 x2, Z1 z1) {
    Y1 y1;
    Y2 y2;
    f(x1, x2, &y1, &y2);
    if ( global_error() ) return;
    g(y1, y2, z1);
  }
};
template <class F, class G, class X1, class X2, class Y1, class Y2, class Z1>
inline Substitution_2_2_0_1<F, G, X1, X2, Y1, Y2, Z1> substitute_2_0_1
(F f, G g, X1*, X2*, Y1*, Y2*, Z1*) {
  return Substitution_2_2_0_1<F, G, X1, X2, Y1, Y2, Z1>(f, g);
}
/* -------------------- 2 arg  (3 value 0 ptr) ->  1 -------------------- */
template <class F, class G, class X1, class X2, class Y1, class Y2, class Y3, 
  class Z1>
class Substitution_2_3_0_1 {
 public:
  F f;
  G g;
  Substitution_2_3_0_1(F f_function, G g_function) 
    : f(f_function), g(g_function) {}
  void operator()(X1 x1, X2 x2, Z1 z1) {
    Y1 y1;
    Y2 y2;
    Y3 y3;
    f(x1, x2, &y1, &y2, &y3);
    if ( global_error() ) return;
    g(y1, y2, y3, z1);
  }
};
template <class F, class G, class X1, class X2, class Y1, class Y2, class Y3, 
  class Z1>
inline Substitution_2_3_0_1<F, G, X1, X2, Y1, Y2, Y3, Z1> substitute_3_0_1
(F f, G g, X1*, X2*, Y1*, Y2*, Y3*, Z1*) {
  return Substitution_2_3_0_1<F, G, X1, X2, Y1, Y2, Y3, Z1>(f, g);
}
/* -------------------------------- 3 arg ------------------------------- */
/* -------------------- 3 arg  (1 value 0 ptr) ->  1 -------------------- */
template <class F, class G, class X1, class X2, class X3, class Y1, class Z1>
class Substitution_3_1_0_1 {
 public:
  F f;
  G g;
  Substitution_3_1_0_1(F f_function, G g_function) 
    : f(f_function), g(g_function) {}
  void operator()(X1 x1, X2 x2, X3 x3, Z1 z1) {
    Y1 y1;
    f(x1, x2, x3, &y1);
    if ( global_error() ) return;
    g(y1, z1);
  }
};
template <class F, class G, class X1, class X2, class X3 class Y1, class Z1>
inline Substitution_3_1_0_1<F, G, X1, X2, X3, Y1, Z1> substitute_1_0_1
(F f, G g, X1*, X2*, X3*, Y1*, Z1*) {
  return Substitution_3_1_0_1<F, G, X1, X2, X3, Y1, Z1>(f, g);
}
/* -------------------- 3 arg  (2 value 0 ptr) ->  1 -------------------- */
template <class F, class G, class X1, class X2, class X3, class Y1, class Y2,
  class Z1>
class Substitution_3_2_0_1 {
 public:
  F f;
  G g;
  Substitution_3_2_0_1(F f_function, G g_function) 
    : f(f_function), g(g_function) {}
  void operator()(X1 x1, X2 x2, X3 x3, Z1 z1) {
    Y1 y1;
    Y2 y2;
    f(x1, x2, x3, &y1, &y2);
    if ( global_error() ) return;
    g(y1, y2, z1);
  }
};
template <class F, class G, class X1, class X2, class X3 class Y1, class Y2, 
  class Z1>
inline Substitution_3_2_0_1<F, G, X1, X2, X3, Y1, Y2, Z1> substitute_2_0_1
(F f, G g, X1*, X2*, X3*, Y1*, Y2*, Z1*) {
  return Substitution_3_2_0_1<F, G, X1, X2, X3, Y1, Y2, Z1>(f, g);
}
/* -------------------------------- 4 arg ------------------------------- */
/* -------------------- 4 arg  (1 value 0 ptr) ->  1 -------------------- */
template <class F, class G, class X1, class X2, class X3, class X4, class Y1,
  class Z1>
class Substitution_4_1_0_1 {
 public:
  F f;
  G g;
  Substitution_4_1_0_1(F f_function, G g_function) 
    : f(f_function), g(g_function) {}
  void operator()(X1 x1, X2 x2, X3 x3, X4 x4, Z1 z1) {
    Y1 y1;
    f(x1, x2, x3, x4, &y1);
    if ( global_error() ) return;
    g(y1, z1);
  }
};
template <class F, class G, class X1, class X2, class X3, class X4, class Y1,
  class Z1>
inline Substitution_4_1_0_1<F, G, X1, X2, X3, X4, Y1, Z1> substitute_1_0_1
(F f, G g, X1*, X2*, X3*, X4*, Y1*, Z1*) {
  return Substitution_4_1_0_1<F, G, X1, X2, X3, X4, Y1, Z1>(f, g);
}

#endif
