// ********************************************************************
//
//  Routine:      rc99Match
//  Author:       T. Oest
//
//  Description:  steering routine for matching
//
//  Modification:
//
// ********************************************************************

// includes
#include <iostream.h>
#include <stdlib.h>
#include <math.h>
#include "marple/marple.hh"

#include "arte/arte.hh"

extern int matchMARPLEVdsEcal;
extern int matchMARPLEVdsRich;
extern int matchMARPLEEcalRich;
extern int matchVdsRich;
extern int matchVdsEcalRich;
extern int matchTarget;

void rc99SelRTRA();
int rc99MarpleRtra();

//
// function
//
int rc99Match()
{
//-----------------------------------------------------------------
//   fit98 matching
//-----------------------------------------------------------------

  rc99SelRTRA();

//-----------------------------------------------------------------
//   marple matching
//-----------------------------------------------------------------
  if (matchMARPLEVdsEcal){
    static float Ktrig = 0.0;
   matchsvdecal_(& Ktrig);
  };
  if (matchMARPLEVdsRich)  matchsvdrich_();
  if (matchMARPLEEcalRich){
   static float Ktrig = 0.0;
   static float RichSb = 0.0;
   matchrichecal_(& Ktrig, & RichSb);
  };

  if( matchMARPLEVdsEcal || matchMARPLEVdsRich || matchMARPLEEcalRich )
    rc99MarpleRtra();


return 0;
};


