*CMZ :          29/10/96  19.31.39  by  T. Oest
*-- Author :    T. Oest   29/10/96

      SUBROUTINE V0INV2(V,W,IRET)

************************************************************************
*
* Description: inversion of 2x2 matrix
*
* Called from:
*
* External references:
*
* Argument in/out description
* V(2,2)   in     input matrix
* W(2,2)   out    inverted matrix
* IRET     out    = 0 ok
*
************************************************************************

      IMPLICIT NONE

#include "arte/Arte.fi"

      DOUBLE PRECISION V(2,2), W(2,2)
      INTEGER          IRET

      DOUBLE PRECISION A

#include "arte/Arte.ff"
C-----------------------------------------------------------------

       A       = V(1,1)*V(2,2)-V(1,2)*V(2,1)
       IF (A.EQ.0.0) THEN
        IRET = -1
       ELSE
        IRET   = 0
        A      = 1./A
        W(1,1) =  A * V(2,2)
        W(2,2) =  A * V(1,1)
        W(1,2) = -A * V(1,2)
        W(2,1) = W(1,2)
       ENDIF

 9000  END

************************************************************************
* End of V0INV2
************************************************************************
