*-- Author :    Hartwig Albrecht   09/03/95

      SUBROUTINE MMINIT (LAST)

************************************************************************
*
* Description: initilaize Memory Management package
*
* Called from: USINIT
*
* External references: none
*
* Arguments: none
*
************************************************************************

      IMPLICIT NONE

#include "arte/Arte.fi"
#include "arte/ArteFlag.fi"
#include "arte/ZMMCOM.fi"
#include "auto/MEMO.fi"
#include "auto/MEMA.fi"
#include "auto/MEIO.fi"

      INTEGER I, J, LAST(1), LOCF

#include "arte/Arte.ff"
#include "auto/MEMO.ff"
#include "auto/MEMA.ff"
#include "auto/MEIO.ff"

      LARLN1 = LOCF(NARLNK)
      LARLNL = LOCF(LAST)
      NARLNK = LARLNL - LARLN1 - 1

C Zebra working space

      CALL MZSTOR (IXSTOR, '/GCBANK/', ' ' ,QFENCE, LQ, LQ(2), LQ(3),
     +             IQ(1000), IQ(NZEBRA))

C Zebra divisions

      CALL MZDIV (IXSTOR, IXCONS, 'constant', 2000, NZEBRA / 2, 'LRC')
      IXEVNT = IXSTOR + 2
      CALL MZXREF (IXCONS, IXEVNT, 'C')
      CALL MZXREF (IXEVNT, IXCONS, 'C')

C Link areas

      CALL MZLINK (IXSTOR, '/ArteLink/', JLINK, LAST, JLINK)
      CALL MZLINK (IXSTOR, '/ZebraLink/', JZEBRA, JZEBRA, JZEBRA)

C Memory management tables. MMBOOK is not yet available.

      CALL MZBOOK (IXCONS, JMEMO, 0, 2, 'MEMO', 0, 0,
     +  JMEMO_NOUT * NARLNK + 2, 0, 0)
      IQ(JMEMO+1) = JMEMO_NOUT
      IQ(JMEMO+2) = NARLNK
      CALL CHCTOH ('(unused)', IQ(HQMEMO_NAME(1,1)), 20)
      IQ(IQMEMO_BOOK(LOCF(JMEMO)-LARLN1)) = 1

      CALL MZBOOK (IXCONS, JMEMA, 0, 2, 'MEMA', 0, 0,
     +  JMEMA_FMAX * 4 + 2, 0, 0)
      IQ(JMEMA+1) = JMEMA_FMAX
      IQ(JMEMA+2) = 4
      IQ(IQMEMO_BOOK(LOCF(JMEMA)-LARLN1)) = 1

      CALL MZBOOK (IXCONS, JMEIO, 0, 2, 'MEIO', 0, 0,
     +  JMEIO_MAXOUT * 99 + 2, 0, 0)
      IQ(JMEIO+1) = JMEIO_MAXOUT
      IQ(JMEIO+2) = 99
      IQ(IQMEMO_BOOK(LOCF(JMEIO)-LARLN1)) = 1

C fill MEMA for relations:

      DO I = 1, 4
        CALL CHCTOH ('relation', IQ(HQMEMA_NAME(1,I)), 20)
        IQ(IQMEMA_TYPE(I)) = 5
        IQ(IQMEMA_IMIN(I)) = 0
        IQ(IQMEMA_IMAX(I)) = ILARGEST
      END DO

      DO I = 1, NMEMO()
        DO J = 1, NAMELEN
          IQ(HQMEMO_NAME(J,I)) = HBLANKSP
        END DO
        IQ(IQMEMO_DIV(I)) = IXCONS
        IQ(BQMEMO_IOD(I)) = 3
        IQ(BQMEMO_IOA(I)) = 3
        IQ(IQMEMO_SUB2(I)) = -1
      END DO

      NMMLUN = 2

      END

************************************************************************
* End of MMINIT
************************************************************************
