*CMZ :          02/05/96  13.15.25  by  Hartwig Albrecht
*-- Author :    Hartwig Albrecht / Rainer Mankel   14/04/96

      SUBROUTINE UTPRIS (NMETA,metype,kwtype)

************************************************************************
*
* Description: initialize PRISM
*
* Called from: KAPRIS, ?
*
* External references: HIGZ
*
* Argument in/out description
*  NMETA   in     name of the metafile
*  METYPE  in     type of metafile (e.g. -112 for PS landscape)
*  KWTYPE  in     type of workstation (e.g. 1...10 for X terminal)
*
************************************************************************

      IMPLICIT NONE

#include "arte/Arte.fi"
#include "arte/ArteFlag.fi"

      INTEGER IOS
      integer kwtype, metype

      CHARACTER *(*) NMETA

#include "arte/Arte.ff"

      IF (PRISINIT .NE. 0)  GO TO 80

      IF (NMETA .EQ. ' ')  THEN
        C78 = JOBNAME
        CALL CH78AC ('.ps')
        CALL IOCONC (LPRIS, C78, 'O', 0)
      ELSE
        CALL IOCONC (LPRIS, NMETA, 'O', 0)
      END IF

      CALL IOOPEN (LPRIS, 'F', 0, IOS)

      CALL IGINIT(0)
      if (kwtype.eq.0) call igwkty(kwtype) ! ask user for wk type
      CALL IGSSE(LSTDO,kwtype)  ! set error unit and wk type
      CALL IGRNG (18., 27.5)    ! paper size

      CALL IGMETA(LPRIS,metype) ! Initialization for ps metafile
      CALL GDINIT()             ! Initialization for Geant display

      call dirinit()            ! Initialization for prism

 80   PRISINIT = 1
      CALL MEWARN ('METAFILE on')

      END

************************************************************************
* End of UTPRIS
************************************************************************
