
      SUBROUTINE KILLGEO

************************************************************************
* written by Siegmund Nowak
*
* This routines inserts fictive volumina to kill tracks
*
* called from geomain
*
************************************************************************

      IMPLICIT NONE

#include "gean/gclink.fi"
#include "gean/ZGMOTH.fi"
#include "arte/Arte.fi"
#include "auto/GEO.fi"
#include "gean/ZGESL.fi"
      INTEGER IROT1,IROT2,IVOL,MEDNUM
      REAL PAR(3),POS(3)
#include "arte/Arte.ff"
#include "auto/GEO.ff"

      
      CALL GSVOLU('KILL','BOX ',MEDNUM(1,'AIR'),PAR,0,IVOL)
      CALL GSATT('KILL','SEEN',0)        
      PAR(2) = 1.

      PAR(1) = 0.5*(FNESL_X2(MAGNSL)-FNESL_X1(MAGNSL))      
      PAR(3) = 0.5*FNESL_Z1(MAGNSL)
      POS(2) = FNESL_Y2(MAGNSL)
      POS(3) = 0.5*(FNESL_Z1(MAGNSL)) + ZZERO
      CALL GSPOSP('KILL',1,'MOTH',0., POS(2),POS(3),0,'ONLY',PAR,3) 
      CALL GSPOSP('KILL',2,'MOTH',0.,-POS(2),POS(3),0,'ONLY',PAR,3) 


      IF(RICHSL.NE.0) THEN
         PAR(1) = 0.5*(FNESL_X2(RICHSL)-FNESL_X1(RICHSL))      
         PAR(3) = 0.5*(FNESL_Z1(RICHSL)-FNESL_Z2(MAGNSL))
         POS(3) = 0.5*(FNESL_Z1(RICHSL)+FNESL_Z2(MAGNSL)) + ZZERO
         CALL GSPOSP('KILL',3,'MOTH',0., 300.,POS(3),0,'ONLY',PAR,3) 
         CALL GSPOSP('KILL',4,'MOTH',0.,-300.,POS(3),0,'ONLY',PAR,3) 
      ENDIF

      PAR(1) = 440. 
      PAR(3) = 510.
      CALL CRROTM(IROT1,90.,0.,99.2,90.,9.2, 90.)
      CALL CRROTM(IROT2,90.,0.,80.8,90.,9.2,270.)
      CALL GSPOSP('KILL',5,'MOTH',0., 380.,610.,IROT1,'ONLY',PAR,3) 
      CALL GSPOSP('KILL',6,'MOTH',0.,-380.,610.,IROT2,'ONLY',PAR,3) 

      PAR(1) = 1. 
      PAR(2) = 350. 
      PAR(3) = 510.
      CALL GSPOSP('KILL',7,'MOTH', 480.,0.,610.,0,'ONLY',PAR,3) 
      CALL GSPOSP('KILL',8,'MOTH',-480.,0.,610.,0,'ONLY',PAR,3) 

 999  RETURN
      END




