#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include "gean/hgdat.h"
#include "arte/arte.hh"
#include "gean/ZGTAR.hh"
#include "gean/zgvers.hh"
#include "gean/ZGESL.h"
#include "arte/ArteMessage.hh"

// ------------------------------------------------------------------------
static int fpp=0;
  FILE *TARG_inp, *utfilp(const char*,const char*);  
  fpos_t ftarpos;
// ------------------------------------------------------------------------  

extern "C" {
  //  void meerro_(char*);
  int tardat_(); 
  extern ZGTAR tarbuf_;   }
  ZGTAR tarbuf_;
// ------------------------------------------------------------------------  
  void tardaterror(char *tag) {
    arteMsg << "tardat: Error in format scanning %s\n" <<tag; arteMsg.error();
  }
// ------------------------------------------------------------------------  

int tardat_() {
  int nitem,  tagid;
  static char name[80];
  static int volid=0;
  char  buffer[256], tag[80], taga[16], tagb[16], tagc[16];    
  char *card, *stop;
  ZGTAR& targ=tarbuf_;
  zgvers ZGVERS;

  if(!fpp){
     strcpy(name,ZGVERS.Get_vers_datafile(LGESL_TAR));
     TARG_inp = utfilp(name,""); 
     if(!TARG_inp) {
        arteMsg <<"Can not open " << name; arteMsg.error();
     }
     fpp=1;
  }

  for(;;) {
     fgetpos(TARG_inp, &ftarpos);
     if(fgets(buffer,256,TARG_inp) == NULL) {
       tagid = 0;
        if(feof(TARG_inp)) {
           if(volid!=0) {
           }
          fclose(TARG_inp);
           tagid = -1; 
	   //           fprintf(stdout," === CLOSE FILE  %s\n",name);  
        }
        return tagid; }
     card=&buffer[0];
     nitem=sscanf(card,"%s",tag);
     if (nitem==-1) continue;   
     card+=itemlength(card,nitem);
     ToLower(tag);
     if (!strncmp(tag,"vol",3)) { 
      if(volid!=0) {
        fsetpos(TARG_inp, &ftarpos);
        tagid = 1;
        volid = 0;
        return tagid;}
      volid = 1;  
      nitem=sscanf(card,"%s %s",taga,tagb);
      if (nitem!=2) tardaterror(tag);
      fillstr(taga,12);
      fillstr(tagb,4);
      strncpy(targ.name,taga,12);
      strncpy(targ.object,tagb,4);            
      targ.type = targ.seen = targ.color = 1;    // default values    
      targ.npar = targ.rotation = 0; 
      targ.dx =targ.dy = targ.dz = targ.du = targ.xb = targ.yb = 0.;
        targ.sxb = targ.syb = 1.;
      strncpy(targ.material,"            ",12);
      strncpy(targ.shape,"    ",4);         
      strncpy(targ.mother,"    ",4);
      strncpy(targ.only,"ONLY",4); }

    else if(!strncmp(tag,"shap",4)) {
      nitem=sscanf(card,"%s ",taga);
      if(nitem!=1) tardaterror(taga);
      fillstr(taga,4);            
      strncpy(targ.shape,taga,4);
      if(!strncmp(taga,"BOX",3) || !strncmp(taga,"TUBE",4)) targ.npar =3; }

 
    else if (!strncmp(tag,"moth",4)) {
      nitem=sscanf(card,"%s",taga);
      if (nitem!=1) tardaterror(tag);
      fillstr(taga,4);       
      strncpy(targ.mother,taga,4);   }   

    else if (!strncmp(tag,"dim",3)) {
      if(targ.npar == 3) {
        nitem=sscanf(card,"%f %f %f",&targ.dx,&targ.dy,&targ.dz); 
        if (nitem!=3) tardaterror(tag); } }

    else if (!strncmp(tag,"typ",3)) {
      nitem=sscanf(card,"%d",&targ.type);
      if (nitem!=1) tardaterror(tag);      }

    else if (!strncmp(tag,"mat",3)) {
      nitem=sscanf(card,"%s",taga);
      if (nitem!=1) tardaterror(tag);
      fillstr(taga,12);       
      strncpy(targ.material,taga,12);   }   

    else if (!strncmp(tag,"only",4)) {
      nitem=sscanf(card,"%s",taga);
      if (nitem!=1) tardaterror(tag);
      fillstr(taga,4);       
      strncpy(targ.only,taga,4);   }   

    else if (!strncmp(tag,"beam",4)) {
      nitem=sscanf(card,"%f %f %f %f ",&targ.xb, &targ.sxb,&targ.yb,&targ.syb);
      if (nitem!=4) tardaterror(tag); } 

    else if(!strncmp(tag,"posit",4)) {
      nitem=sscanf(card,"%f %f %f ",&targ.xpos,&targ.ypos,&targ.zpos);
      if(nitem!=3) tardaterror(tag);}
 
    else if (!strncmp(tag,"rel_p",5)) {
      nitem=sscanf(card,"%s %s %s",taga,tagb,tagc); 
        if (nitem!=3) tardaterror(tag); 
        targ.xpos = targ.xpos + strtod(taga,&stop);
        targ.ypos = targ.ypos + strtod(tagb,&stop);
        targ.zpos = targ.zpos + strtod(tagc,&stop);  }

    else if (!strncmp(tag,"rot",3)) {
      nitem=sscanf(card,"%d",&targ.rotation); 
      if (nitem!=1) tardaterror(tag);    }


    else if (!strncmp(tag,"col",3)) {
      nitem=sscanf(card,"%d",&targ.color);
      if (nitem!=1) tardaterror(tag);      
      if(targ.color!=0) targ.seen=1;  }

     else  {
      if(strncmp(tag,"*",1) && strncmp(tag,"#",1))
        printf("tag not found:   %s\n",tag);}
    }
}
