*CMZ :          02/08/96  13.58.39  by  Fedor Ratnikov
*CMZ :  1.00/00 07/12/94  03.15.28  by  Fedor Ratnikov
*-- Author :    Fedor Ratnikov   23/09/94
************************************************************************
*
* L1INIT
* written by Fedor Ratnikov, 23/09/94 13.20.50
*
* This routines action:
* Perform general initialization
*
*
* Arguments  kind         description
*          (in,update,out)
*----------------------------------------------------------------------*
* ierr        out           .NE.0 when fail
*
*
************************************************************************
c

      SUBROUTINE L1INIT(ierr)
c
      IMPLICIT NONE
c
#include "arte/Arte.fi"
#include "l1si/l1param.fi"
#include "l1si/l1clink.fi"
c
      INTEGER ierr
c
      ierr = 0
c
c     initialize ZEBRA LINK area
c
      CALL MZLINK(IXCONS,'/L1CLIN/',L1JDET,JL1HI_E,L1JDET)
c
c     initialize pipeline structure
c
      CALL L1BXINI
c
c     --- initialize at time-stamp 0
      CALL l1allin(0,ierr)
      CALL L1BXRST(0)           ! store initial state

      RETURN
c
      END
