*CMZ :  1.00/00 03/01/95  11.05.48  by  Dominik Ressing
*CMZ :  0.01/02 22/08/94  12.18.25  by  Dominik Ressing
*CMZ :  0.01/01 25/07/94  17.09.41  by  Dominik Ressing
*-- Author :    Dominik Ressing   20/07/94
************************************************************************************
*
* L1MESDA
* written by Dominik Ressing, 20/07/94 18.31.03
*
* This routines action:
* Deactivates message: fill message fields accordingly and maintain the
* BX trace pointers/counters L1MEbx.
*
* Variables   kind         description
*          (in,update,out)
*-----------------------------------------------------------------------------------
* Lmess        in          pointer to message in L1MEstor
*
************************************************************************************
c
      SUBROUTINE L1MESDA(Lmess)
c
      IMPLICIT NONE
#include "l1si/l1param.fi"
#include "l1si/l1geodf.fi"
#include "l1si/l1mesdf.fi"
c
      INTEGER Lmess,iBX,nBX
c
      iBX = L1MEstor(Lmess+L1MEprbx)
c
      IF ( L1MEstor(Lmess+L1MEactive).gt.0 ) THEN   ! is this message active ?
         nBX = L1MEbx(L1MEBXnact,iBX)               ! number of active messaages for BX
         nBX = nBX - 1
         L1MEstor(Lmess+L1MEactive) =
     &        -1*L1MEstor(Lmess+L1MEactive)
c
         IF ( nBX.lt.0 ) THEN   ! this should never happen
            WRITE(L1LUNprn,*)
     &        'L1MESDA ==> invalid message-active count',
     &        nBX,iBX
            nBX = 0
         ELSE IF ( nBX.eq.0 ) THEN
            CALL l1messc(iBX)  ! delete all messages for BX
            CALL l1usrev(iBX)
            CALL l1datsc(iBX)  ! scratch detector data for BX
         END IF
c
         L1MEbx(L1MEBXnact,iBX) = nBX
      END IF
c
      RETURN
c
      END
