*CMZ :          09/05/96  14.50.32  by  Fedor Ratnikov
*CMZ :  1.00/00 02/12/94  19.10.02  by  Dominik Ressing
*CMZ :  0.01/02 12/08/94  12.48.23  by  Dominik Ressing
*-- Author :    Dominik Ressing   28/07/94
************************************************************************
*
* L1PRNSL
* written by Dominik Ressing, 28/07/94 19.05.59
*
* This routines action:
************************************************************************
c
      SUBROUTINE L1PRNSL
c
      IMPLICIT NONE
c
#include "gean/gcbank.fi"
#include "l1si/l1param.fi"
#include "l1si/l1clink.fi"
#include "l1si/l1detuse.fi"
#include "l1si/l1geodf.fi"
#include "l1si/l1detdf.fi"
      CHARACTER*4 CQ(1)
      EQUIVALENCE(Q(1),CQ(1))
c
      INTEGER isl,ilay,isec
      INTEGER iDetSpe(L1DETSPElen),
     &     iGeoInf,iDetInf,iCellGeo
c
      do isl=1,l1nDetUsed
       if(CQ(L1JDET+isl).ne.'CALW')  then  ! skip ecal
        iDetSpe(L1DETSPEdet) = isl
        iDetSpe(L1DETSPElayer) = 1
        iDetSpe(L1DETSPEsection) = 1
        call l1detif(iDetSpe,iGeoInf,iDetInf,iCellGeo)
        WRITE(L1LUNprn,999)
        do ilay=1,IQ(iDetInf+L1DETINFnlay)
         iDetSpe(L1DETSPElayer) = ilay
         do isec=1,IQ(iDetInf+L1DETINFnsec)
          iDetSpe(L1DETSPEsection) = isec
          call l1detif(iDetSpe,iGeoInf,iDetInf,iCellGeo)
          WRITE(L1LUNprn,1000) CQ(L1JDET+isl),ilay,isec,
     &         Q(iGeoInf+L1GEOINFx0),Q(iGeoInf+L1GEOINFsx),
     &         Q(iGeoInf+L1GEOINFy0),Q(iGeoInf+L1GEOINFsy),
     &         Q(iGeoInf+L1GEOINFz),Q(iGeoInf+L1GEOINFsin_al),
     &         IQ(iDetInf+L1DETINFnRow),IQ(iDetInf+L1DETINFnCol),
     &         Q(iDetInf+L1DETINFxspace),Q(iDetInf+L1DETINFyspace),
     &         Q(iDetInf+L1DETINFxlap),Q(iDetInf+L1DETINFylap),
     &         IQ(iDetInf+L1DETINFwirepad)
         enddo
        enddo
       endif
      enddo
c
      RETURN
 999  FORMAT(' nam la se   x0      sx     y0     sy     z    sin   r  ',
     &     'c   xspa   yspa    xlap  ylap  w/p')
 1000 FORMAT(a4,2i3,4f7.1,f7.0,f6.3,i4,i3,f7.2,f8.2,2f6.2,i3)
c
      END
