*-- Author :    A. Spiridonov   06/11/98

      subroutine tfunco()
*
*     Control routine for weedout of clones
*     
*             

      implicit none
*
#include "rang/zfpar.fi"
#include "rang/zfmode.fi"

#include "arte/Arte.fi"
#include "auto/RSEG.fi"
#include "arte/RSEG_cmp.fi"
*
*     **** packing scheme for covariance
      integer matrix_pack(5,5)
      data matrix_pack
     +     / 1,  2,  4,  7, 11,
     +       2,  3,  5,  8, 12,
     +       4,  5,  6,  9, 13,
     +       7,  8,  9, 10, 14,
     +      11, 12, 13, 14, 15 /
      save matrix_pack
* 
      integer rgseg2t
      integer rs,rt,iirs,ind_rs,rbeg
      integer if_seg,segVec(2)
      integer rgfitsv

#include "arte/Arte.ff"
#include "auto/RSEG.ff"

*--------------------------------------------------

*      go to 999

      if(jrseg.le.0)   go to 999           ! skip empty event
      if(NRSEG().le.0) go to 999 

      if(rlevel_zfpar.eq.2.or.rlevel_zfpar.eq.3) then
#ifdef UN_RFIT
        do rs=1,nrseg()
           call rgfit(rs,0)     ! full refit
        enddo
#endif

        call rguniq()           ! kill the clones

#ifdef UN_TEST
        do rs=1,nrseg()
           if (iand(irseg_cmp(rs),rsegc_bitsign).eq.0) then
              rt = rgseg2t(rs)  ! copy alive segments to track table
           else
*              print *,' usevnt: segment is killed, rs=',rs
           endif
        enddo
#endif

      else if(rlevel_zfpar.eq.4) then

#ifdef UN_RFIT
        do rs=1,NRSEG()
          rbeg = 0
          do 110 iirs=1,20
            if(iirs.eq.1) then
              ind_rs = prseg_rbeg(rs)
            else 
              ind_rs = xrseg_rbeg(ind_rs)
            end if
            if(ind_rs.eq.0) go to 111
            rbeg = mrseg_rbeg(ind_rs)      
         
*            print '("tfunco : rbeg,rseg ",2i5)',rbeg,rs

  110     continue
  111     continue

          if(rbeg.gt.0) then          ! treat pair of segments
            segVec(1) = rbeg          
            segVec(2) = rs
            if_seg = 1
*            print '("tfunco : ..... try fit segments ",2i5)'
*     +               ,segVec(1),segVec(2)
            if(rgfitsv(segVec,2,0).eq.0) then
*              print '("tfunco : +++++ OK fit segments ",2i5)'
*     +               ,segVec(1),segVec(2)
            else 
*              print '("tfunco : ----- failed fit segments ",2i5)'
*     +               ,segVec(1),segVec(2)

              if_seg = 0 
           end if

          end if                    ! end treat pair of segments
        end do                      ! end of loop on segments
#endif

        call rguniq()           ! kill the clones

#ifdef UN_TEST                      
        do rs=1,nrseg()
          if (iand(irseg_cmp(rs),rsegc_bitsign).eq.0) then
            if (iand(irseg_cmp(rs),rsegc_magt   ).ne.0 ) then
               rt = rgseg2t(rs)  ! copy alive segments to track table
            end if
*            print *,' tfunco:            segment is copied, rs=',rs
          else
*             print *,' tfunco: segment is killed, rs=',rs
          endif
        enddo
#endif

      end if                        ! end of rlevel_zfpar = 4
 
 999  end

