      subroutine tfversion()

************************************************************************
*                                                                      *
*  Author: Rainer Mankel                                               *
*                                                                      *
*  Creation date: 10-Nov-96                                            *
*                                                                      *
************************************************************************

*     **** print ranger version id 
      implicit none

      call mewarn('ranger 4.15/00 ')

      end


************************************************************************
* Version history:
*
* 4.15/00 - Improved composite layer construction in rgdom.
*           Downstream propagation added.
*           External seed propagation added.
* 4.14/04 - Correction in tfcontyn. Some printouts changed or removed.
* 4.14/03 - Removal of stop and exit statements
* 4.14/02 - New routine tfremv.
* 4.14/01 - Muon segment treatment included in tfbuild.F
*           Pattern tracker segments stored by tfbuild.F
*           Reduced output from new navigator
* 4.14/00 - New navigator. (Many new files)
*           Many changes for modular geometry.
*           Setting of qptEst in HitBase introduced (for holmes fitting)
*           Superlayer setting in dmlay fixed.
*           tfkuip splitted.
*           dgsel selection in old navigator.
*           New parameters qualminX,qualminY,nhitmin,whitmin,
*               dgsel,navmode in zfpar.
*           Search of appropriate mimp improved in tftparm.
*           Monitor class.
* 4.13/00 - autosort in Track.C constructors, new scheme in Geom.C,
*           MS06 included in navigation table (dmdef.F),
*           modified reference track criteria because of new 
*           layer structure in magnet (tfref.F,tfstam1.F)
* 4.12/04 - RCCL copy in seg2Track.C, rgideal checks segstor before 
*           storing RTRA, no refit after pattern reco in rgmaintr,
*           no exit on dz exception in Track.C
* 4.12/03 - Bug fix in ::storeRpnt in State.hh,StateP.hh and StateP.C
* 4.12/02 - The routine rgmaintr() was introduced which is the user routine 
*           for standard main tracker reconstruction in the full geometry. 
* 4.12/01 - self-initialization, fixes in seg2track.C,tftcre.F,RMap.C,
*           removal of mc_zf,mimp_zf
* 4.12/00 - adaption to ARTE-02-05 and new C++ interface
* 4.11/00 - TC propagation, clone weedout, SVD integration, control 
*           structures
* 4.10/00 - condUpdate, hitb constructors, domain name printout, rgsv2t
* 4.09/02 - SI08 included in navigation table
* 4.09/00 - object oriented ranger fit,
*           fast magnet propagation
*           rtdir remains removed
* 4.08/02 - hardcoded domains fixed (tfdzone2.F), zmax_ec  (tfinit.F)
*           rinit (tfrfseg.F), rtdir replaced (tftpar2.F),
*           rkmain parameter list (tftrkut.F)
* 4.08/01 - modulo 2**16 in igede_sec (dmdir.F): release as ranger 4.8
* 4.08/00 - same
* 4.07/06 - new rk routines (T. Oest, T. Kuhn-Sander)
* 4.07/05 - overdue cvs add
* 4.07/04 - new include file reference scheme
*
************************************************************************


