// ********************************************************************
//
//  Routine:      rc99Aevnt (no action for MC)
//  Author:       T.Oest/D.Samtleben
//
//  Description:  event reconstruction
//
//  Modification:
//                            matching added      03/06/99 Oest
//
// ********************************************************************


#include <iostream.h>
#include <stdlib.h>
#include "arte/arte.hh"
#include "reco/rc99Areco.hh"

static int firstcall = 1;

int rc99Arefit();
//void rc99Avertex();

//*****************************************************************
// function   no action for MC
//*****************************************************************

void rc99Aevnt() {

//==================================================================
// 1. initialization, return for MC
//==================================================================

  ArtePointer<EVHD> header(1);

  if (ArteTable<MTRA>::begin() != ArteTable<MTRA>::end()){
     if (header->exp > 0 )         header->exp = -1;
  };

     if (firstcall == 1 ) {
      firstcall = 0;
      rc99Ainit();
     };

//==================================================================
// 2. stand alone reconstruction
//==================================================================

   int rcStandAloneFlag = 0;
   rcStandAloneFlag     = rc99AStandAlone();
  
//==================================================================
// 3. matching
//==================================================================

   int MatchingFlag = rc99Match();
  
//==================================================================
// 4. refit of tracks
//==================================================================

   int refit = 0;
   refit     = rc99Arefit();

//==================================================================
// 5. Particle ID
//==================================================================

   //   int ParticleID = 0;
   //   ParticleID     = rc99AParticleID();
//==================================================================
// 6. vertexing
//==================================================================

   //  rc99Avertex();
  


}
